package netscape.ldap.controls;

import java.io.ByteArrayInputStream;
import netscape.ldap.LDAPControl;
import netscape.ldap.LDAPSortKey;
import netscape.ldap.ber.stream.BERConstruct;
import netscape.ldap.ber.stream.BERElement;
import netscape.ldap.ber.stream.BEREnumerated;
import netscape.ldap.ber.stream.BEROctetString;
import netscape.ldap.ber.stream.BERSequence;
import netscape.ldap.ber.stream.BERTag;
import netscape.ldap.client.JDAPBERTagDecoder;

public class LDAPSortControl extends LDAPControl {
   public static final String SORTREQUEST = "1.2.840.113556.1.4.473";
   public static final String SORTRESPONSE = "1.2.840.113556.1.4.474";

   public LDAPSortControl(LDAPSortKey var1, boolean var2) {
      super("1.2.840.113556.1.4.473", var2, (byte[])null);
      LDAPSortKey[] var3 = new LDAPSortKey[]{var1};
      super.m_value = this.createSortSpecification(var3);
   }

   public LDAPSortControl(LDAPSortKey[] var1, boolean var2) {
      super("1.2.840.113556.1.4.473", var2, (byte[])null);
      super.m_value = this.createSortSpecification(var1);
   }

   public static String parseResponse(LDAPControl[] var0, int[] var1) {
      String var2 = null;
      LDAPControl var3 = null;

      for(int var4 = 0; var0 != null && var4 < var0.length; ++var4) {
         if (var0[var4].getID().equals("1.2.840.113556.1.4.474")) {
            var3 = var0[var4];
            break;
         }
      }

      if (var3 != null) {
         ByteArrayInputStream var5 = new ByteArrayInputStream(var3.getValue());
         new BERSequence();
         JDAPBERTagDecoder var6 = new JDAPBERTagDecoder();
         int[] var7 = new int[]{0};

         try {
            BERSequence var8 = (BERSequence)BERElement.getElement(var6, var5, var7);
            int var9 = ((BEREnumerated)((BERConstruct)var8).elementAt(0)).getValue();
            if (var1 != null && var1.length > 0) {
               var1[0] = var9;
            }

            BEROctetString var10 = (BEROctetString)((BERConstruct)var8).elementAt(1);
            var2 = new String(var10.getValue(), "UTF8");
         } catch (Throwable var11) {
         }
      }

      return var2;
   }

   private byte[] createSortSpecification(LDAPSortKey[] var1) {
      BERSequence var2 = new BERSequence();

      for(int var3 = 0; var3 < var1.length; ++var3) {
         BERSequence var4 = new BERSequence();
         ((BERConstruct)var4).addElement(new BEROctetString(var1[var3].getKey()));
         if (var1[var3].getMatchRule() != null) {
            ((BERConstruct)var4).addElement(new BERTag(128, new BEROctetString(var1[var3].getMatchRule()), true));
         }

         if (var1[var3].getReverse()) {
            ((BERConstruct)var4).addElement(new BERTag(129, new BEREnumerated(129), true));
         }

         ((BERConstruct)var2).addElement(var4);
      }

      return ((LDAPControl)this).flattenBER(var2);
   }
}
